/*
 * CTRLS.h
 *
 *  Created on: 25.08.2019
 *      Author: alexanderbaumgartner
 *
 *  This file is part of ELoadV1_6.

    ELoadV1_6 is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    ELoadV1_6 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ELoadV1_6.  If not, see <http://www.gnu.org/licenses/>.

*/

#ifndef DL_CTRLS_H_
#define DL_CTRLS_H_

/* Controllers for the load */

/* Definitions */

#define F_CTRL          10140.0f //Frequency of the whole controller algorithm

#define CTRL_MOD_NON    0 //No Mode set -> Startup
#define CTRL_MOD_CURR   1
#define CTRL_MOD_VOLT   2
#define CTRL_MOD_PWR    3
#define CTRL_MOD_RES    4

#define LOAD_EN          0xFF
#define LOAD_OFF         0x00

#define ERR_NO_ERR          (uint8_t)(0)
#define ERR_LIM_OVERCURR    (uint8_t)(1<<0)
#define ERR_LIM_OVERVOLT    (uint8_t)(1<<1)
#define ERR_LIM_OVERPOW     (uint8_t)(1<<2)
#define ERR_LIM_UVLO        (uint8_t)(1<<3)
#define ERR_LIM_OVERTEMP    (uint8_t)(1<<4)
#define ERR_COM_TIMEOUT     (uint8_t)(1<<5)
#define ERR_COM_CHECKSUM    (uint8_t)(1<<5)
#define ERR_NO_INIT         (uint8_t)(1<<7)


void configureStdValues();
void calculateActValues();
void calculateFiltValues();
void LoadCtrl();
uint8_t checkLimits();
void currentController();
void voltageController();

#endif /* DL_CTRLS_H_ */
