/*
 * PID.c
 *
 *  Created on: 29.11.2019
 *      Author: alexanderbaumgartner
 *  This file is part of ELoadV1_6.

    ELoadV1_6 is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    ELoadV1_6 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ELoadV1_6.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
#include "../tivaHeaders.h"
#include "../Globals.h"
#include "PID.h"

#include <float.h>
#include <math.h>




/* PI Controller Functions */
void piInit(pi_t *pi_con)
{
  pi_con->e = 0.0f;
  pi_con->e_old = 0.0f;
  pi_con->u = 0.0f;
  pi_con->u_old = 0.0f;
}
void piController(pi_t *pi_con,float ref,float act)
{
  pi_con->e = ref - act;

  pi_con->u = pi_con->u_old + pi_con->par_Kp*(pi_con->e - pi_con->e_old) + pi_con->par_Ki * pi_con->par_Ts * 0.5f * (pi_con->e + pi_con->e_old);

    if(pi_con->u < pi_con->par_min)
    pi_con->u=pi_con->par_min;
  else if(pi_con->u > pi_con->par_max)
    pi_con->u=pi_con->par_max;

  pi_con->u_old = pi_con->u;
  pi_con->e_old = pi_con->e;
}
