/*
 * Clock.c
 *
 *  Created on: 16.06.2019
 *      Author: alexanderbaumgartner
 *
 *  This file is part of ELoadV1_6.

    ELoadV1_6 is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    ELoadV1_6 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ELoadV1_6.  If not, see <http://www.gnu.org/licenses/>.
 */
#include "../tivaHeaders.h"
#include "Clock.h"
#include "../Globals.h"

extern uint32_t uptime;

//50Mhz Clock speed
void initClock()
{
    SysCtlClockSet(SYSCTL_SYSDIV_4|SYSCTL_USE_PLL|SYSCTL_XTAL_16MHZ|SYSCTL_OSC_MAIN);
}

void delay_ms(float delaytime)
{
    SysCtlDelay((uint32_t)(((float)SysCtlClockGet())*delaytime/3000.0f));
}

void initSysTickSecondCounter()
{
    SysTickPeriodSet(SysCtlClockGet()/10); //Every 100ms
    SysTickIntRegister(ISR_Systick);
    SysTickEnable();
    uptime=0ul;
}

void ISR_Systick()
{
    uptime+=100;
}
