/*
 * IOs.c
 *
 *  Created on: 16.06.2019
 *      Author: alexanderbaumgartner
 *
 *  This file is part of ELoadV1_6.

    ELoadV1_6 is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    ELoadV1_6 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ELoadV1_6.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "../tivaHeaders.h"
#include "IOs.h"
#include "../Globals.h"


void initIOs()
{
    //enable all ports
    ROM_SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOA);
    while(!SysCtlPeripheralReady(SYSCTL_PERIPH_GPIOA))
    {;}
    ROM_SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOB);
    while(!SysCtlPeripheralReady(SYSCTL_PERIPH_GPIOB))
    {;}
    ROM_SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOC);
    while(!SysCtlPeripheralReady(SYSCTL_PERIPH_GPIOC))
    {;}
    ROM_SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOD);
    while(!SysCtlPeripheralReady(SYSCTL_PERIPH_GPIOD))
    {;}
    ROM_SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOE);
    while(!SysCtlPeripheralReady(SYSCTL_PERIPH_GPIOE))
    {;}
    SysCtlPeripheralEnable(SYSCTL_PERIPH_GPIOF);
    while(!SysCtlPeripheralReady(SYSCTL_PERIPH_GPIOF))
    {;}

    initLeds();
}

void initLeds()
{
    GPIOPinTypeGPIOOutput(GPIO_PORTF_BASE, PIN_RED_LED|PIN_BLUE_LED|PIN_GREEN_LED);
}

void writeLeds(uint32_t leds)
{
    GPIOPinWrite(GPIO_PORTF_BASE, PIN_RED_LED|PIN_BLUE_LED|PIN_GREEN_LED, leds);
}
void toggleLeds(uint32_t leds)
{
    uint32_t act = GPIOPinRead(GPIO_PORTF_BASE,PIN_RED_LED|PIN_BLUE_LED|PIN_GREEN_LED);

    act ^= leds;
    writeLeds(act);

}
void initOPAMPSwitch()
{
    GPIOPinTypeGPIOOutput(GPIO_PORTA_BASE,PIN_OPAMP_EN);
    GPIOPinWrite(GPIO_PORTA_BASE, PIN_OPAMP_EN, 0xFF);

}

void EnableOPAMP()
{
    if(GPIOPinRead(GPIO_PORTA_BASE,PIN_OPAMP_EN) != 0)
        GPIOPinWrite(GPIO_PORTA_BASE, PIN_OPAMP_EN, 0x00);
}

void DisableOPAMP()
{
    if(GPIOPinRead(GPIO_PORTA_BASE,PIN_OPAMP_EN) == 0)
        GPIOPinWrite(GPIO_PORTA_BASE, PIN_OPAMP_EN, 0xFF);
}
