/*
 * SPI.h
 *
 *  Created on: 19.06.2019
 *      Author: alexanderbaumgartner
 *
 *  This file is part of ELoadV1_6.

    ELoadV1_6 is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    ELoadV1_6 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ELoadV1_6.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef HAL_SPI_H_
#define HAL_SPI_H_

#define SPI2_SPEED  2000000//1M//500000//0.5M

#define SPI2_CS1_PIN    GPIO_PIN_3
#define SPI2_CS1_BASE   GPIO_PORTB_BASE
#define SPI2_CS2_PIN    GPIO_PIN_1
#define SPI2_CS2_BASE   GPIO_PORTB_BASE

//DAC
#define DAC_CONF_GAIN       1 //1-> 1xVref, 0 -> 2xVref
#define DAC_CONF_VREF_BUF   1 //1-> Buffered, 0 -> unbuffered

void writeDACValue();

void readADCValue(uint8_t channel);

void initSPI2();
void ISR_SPI2();

void statemachine_SPI_init_and_start();
void statemachine_SPI();


#endif /* HAL_SPI_H_ */
