/*
 * UART.h
 *
 *  Created on: 16.06.2019
 *      Author: alexanderbaumgartner
 *
 *  This file is part of ELoadV1_6.

    ELoadV1_6 is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    ELoadV1_6 is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with ELoadV1_6.  If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef HAL_UART_H_
#define HAL_UART_H_
#include "../tivaHeaders.h"

#define UART_BUF_SIZE       64

#define UART_RX_SIZE        24
#define UART_TX_SIZE        24
#define UART_RX_SIZE_CONF   52
union serial_buf_t
{
  float f[UART_BUF_SIZE/4];
  uint8_t ui8[UART_BUF_SIZE];
  int8_t i8[UART_BUF_SIZE];
  uint16_t ui16[UART_BUF_SIZE/2];
  int16_t i16[UART_BUF_SIZE/2];
};

typedef struct
{
    union serial_buf_t sendbuf;
    union serial_buf_t recbuf;
    uint8_t rx_cnt;
    uint8_t tx_cnt;
    uint8_t checksum1;
    uint8_t is_configdata;
    uint8_t rx_ok;
    uint8_t tx_now;
    uint32_t last_rx;

} serial_t;

serial_t serial;

void initUART();
void writeUART(uint8_t* buf,uint8_t len);
void ISR_uart();
void readDataUART();
void writeBackDataUART();

#endif /* HAL_UART_H_ */
